using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace freeSQL
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] Args)
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            if (Args.Length == 0)
                Application.Run(new frmSQL("", "", ""));
            else if (Args.Length == 1 && Args[0] == "-plus")
                Application.Run(new frmSQL("", "", Args[0]));
            else if (Args.Length == 2)
                Application.Run(new frmSQL(Args[0], Args[1], ""));
            else if (Args.Length == 3 && Args[2] == "-plus")
                Application.Run(new frmSQL(Args[0], Args[1], Args[2]));
            else
            {
                Version v = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;
                string s = "FreeSQL version " + v.Major.ToString() + "." + v.Minor.ToString() + "." + v.Build.ToString()+"\n\n";
                s += "usage freeSQL [<Provider> <ConnectionString>] [-plus] \n";
                s += "<Provider> Specifies the provider (e.g. System.Data.OracleClient) \n";
                s += "<ConnectionString> e.g. \"Data source=oracle; user id=scott; password=tiger\"\n";
                s += "-plus Enable commit of changes and non-select query execution";
                MessageBox.Show(s, Application.ProductName);
            }
        }
    }
}