﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace freeSQL
{
    public partial class frmImport : Form
    {
        public string[] retVal = new string[3];
        public frmImport(string tableName)
        {
            InitializeComponent();
            if (tableName == "")
                info.Text = "No object was selected\r\nImport will create table automatically based on the file name";
            else
                info.Text = "Importing data into " + tableName + "\r\nPlease specify options below";
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "XML format|*.xml|Text files (txt,csv,dat)|*.txt;*.csv;*.dat";
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            if (openFileDialog1.FileName == "") return;
            txtFileName.Text = openFileDialog1.FileName;

            if (System.IO.Path.GetExtension(txtFileName.Text).ToLower() == ".xml")
            {
                txtDelimiter.Enabled = false;
                ckFldNames.Enabled = false;
            }
            else
            {
                txtDelimiter.Enabled = true;
                ckFldNames.Enabled = true;
            }

        }
        private void btnOk_Click(object sender, EventArgs e)
        {
            if (System.IO.Path.GetExtension(txtFileName.Text).ToLower() != ".xml" && txtDelimiter.Text == "")
            {
                MessageBox.Show("Delimiter cannot be empty");
                return;
            }

            retVal[0] = txtFileName.Text;
            retVal[1] = txtDelimiter.Text;
            retVal[2] = (ckFldNames.Checked ? "T" : "F");
            this.Close();
        }
        private void btnCancel_Click(object sender, EventArgs e)
        {
            retVal = null;
            this.Close();
        }
    }
}
