using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;

namespace freeSQL
{
    public partial class frmOptions : Form
    {
        netlib.netlib7 n7 = new netlib.netlib7();

        public frmOptions()
        {
            InitializeComponent();
        }

        private void Options_Load(object sender, EventArgs e)
        {
            MaxRecords.Value = n7.nvl(Registry.GetValue("HKEY_CURRENT_USER\\Software\\FreeSQL", "optMaxRecords", null), 100);
            ckShowAllObj.Checked = Convert.ToBoolean(Registry.GetValue("HKEY_CURRENT_USER\\Software\\FreeSQL", "optShowAllObj", false));

            FontConverter fConv = new FontConverter();
            string s0 = n7.nvl(Registry.GetValue("HKEY_CURRENT_USER\\Software\\FreeSQL", "optFontExplorer", ""));
            string s1 = n7.nvl(Registry.GetValue("HKEY_CURRENT_USER\\Software\\FreeSQL", "optFontSql", ""));
            string s2 = n7.nvl(Registry.GetValue("HKEY_CURRENT_USER\\Software\\FreeSQL", "optFontGrid", ""));
            string s3 = n7.nvl(Registry.GetValue("HKEY_CURRENT_USER\\Software\\FreeSQL", "optFontEdit", ""));
            if (s0 != "") tvFont.Font = (Font)fConv.ConvertFromString(s0);
            if (s1 != "") sqlTextFont.Font = (Font)fConv.ConvertFromString(s1);
            if (s2 != "") gridFont.Font = (Font)fConv.ConvertFromString(s2);
            if (s3 != "") editFont.Font = (Font)fConv.ConvertFromString(s3);
        }
        private void btnOK_Click(object sender, EventArgs e)
        {
            FontConverter fConv = new FontConverter();

            RegistryKey rk = Registry.CurrentUser.CreateSubKey("Software\\FreeSQL");
            rk.SetValue("optMaxRecords", MaxRecords.Value.ToString(), RegistryValueKind.String);
            rk.SetValue("optShowAllObj", ckShowAllObj.Checked, RegistryValueKind.DWord);
            rk.SetValue("optFontExplorer", fConv.ConvertToString(tvFont.Font), RegistryValueKind.String);
            rk.SetValue("optFontSql", fConv.ConvertToString(sqlTextFont.Font), RegistryValueKind.String);
            rk.SetValue("optFontGrid", fConv.ConvertToString(gridFont.Font), RegistryValueKind.String);
            rk.SetValue("optFontEdit", fConv.ConvertToString(editFont.Font), RegistryValueKind.String);
            this.Close();
        }
        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void tvFont_DoubleClick(object sender, EventArgs e)
        {
            FontDialog fd = new FontDialog();
            fd.Font = tvFont.Font;
            if (fd.ShowDialog(this) == DialogResult.OK)
                tvFont.Font = fd.Font;
        }
        private void sqlTextFont_DoubleClick(object sender, EventArgs e)
        {
            FontDialog fd = new FontDialog();
            fd.Font = sqlTextFont.Font;
            if (fd.ShowDialog(this) == DialogResult.OK)
                sqlTextFont.Font = fd.Font;
        }
        private void gridFont_DoubleClick(object sender, EventArgs e)
        {
            FontDialog fd = new FontDialog();
            fd.Font = gridFont.Font;
            if (fd.ShowDialog(this) == DialogResult.OK)
                gridFont.Font = fd.Font;
        }

        private void editFont_DoubleClick(object sender, EventArgs e)
        {
            FontDialog fd = new FontDialog();
            fd.Font = editFont.Font;
            if (fd.ShowDialog(this) == DialogResult.OK)
                editFont.Font = fd.Font;
        }
    }
}