﻿using System;
using System.Data;
using System.Data.Common;
using System.Windows.Forms;
using netlib;

namespace freeSQL
{
    public partial class frmParams : Form
    {
        public string fields;
        public DbParameter[] parameters;
        netlib7 n7 = new netlib7();

        public frmParams()
        {
            InitializeComponent();
        }

        private void frmParams_Activated(object sender, EventArgs e)
        {
            TextBox t = (TextBox)this.Controls.Find("t_" + fields.Split(';')[0], false)[0];
            t.Focus();
        }
        private void frmParams_Load(object sender, EventArgs e)
        {
            int monitorHeight = SystemInformation.PrimaryMonitorSize.Height - 100;
            int monitorWidth = SystemInformation.PrimaryMonitorSize.Width - 100;
            int top = 40;
            int left = 10;
            int formWidth = 370;

            string[] f = fields.Split(';');

            for (int i = 0; i < f.Length; i++)
            {
                Label l = new Label();
                l.Name = "l_" + f[i];
                l.Text = f[i];
                l.Top = top;
                l.Left = left;
                l.Width = 120;
                this.Controls.Add(l);

                TextBox t = new TextBox();
                t.Name = "t_" + f[i];
                t.Top = top;
                t.Left = l.Left + l.Width + 10;
                t.Width = 200;
                t.BringToFront();
                if (parameters != null)
                {
                    for (int j = 0; j < parameters.Length; j++)
                    {
                        if (parameters[j].ParameterName == f[i])
                        {
                            t.Text = parameters[j].Value.ToString();
                            break;
                        }
                    }
                }
                this.Controls.Add(t);
                top += 22;

                if (top > monitorHeight)
                {
                    top = 50;
                    left = left + 350;
                    formWidth = formWidth * 2;
                    this.Height = monitorHeight;
                }
            }

            if (this.Height != monitorHeight)
                this.Height = top + 60;

            if (formWidth > monitorWidth)
                this.Width = monitorWidth;
            else
                this.Width = formWidth;
        }
        private void frmParams_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyData == (Keys.Enter))
                btnOk_Click(null, null);
            else if (e.KeyData == Keys.Escape)
                btnCancel_Click(null, null);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            parameters = null;
            this.Close();
        }
        private void btnOk_Click(object sender, EventArgs e)
        {
            string[] f = fields.Split(';');
            parameters = new DbParameter[f.Length];

            for (int i = 0; i < f.Length; i++)
            {
                Control[] t = this.Controls.Find("t_" + f[i], false);
                string fieldValue = ((TextBox)t[0]).Text;

                parameters[i] = n7.CreateParameter();
                parameters[i].ParameterName = f[i];
                if (fieldValue == "")
                    parameters[i].Value = DBNull.Value;
                else if (n7.IsDate(fieldValue))
                    parameters[i].Value = Convert.ToDateTime(fieldValue);
                else
                    parameters[i].Value = fieldValue;
            }
            this.Close();
        }
    }
}
