using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace freeSQL
{
    public partial class frmRecall : Form
    {
        string returnValue;
        public string ReturnValue
        {
            get { return returnValue; }
        }

        public frmRecall()
        {
            InitializeComponent();

            getHistory("");
            returnValue = "";

            dataGridView1.Font = new Font(FontFamily.GenericSansSerif, 9);
        }
        private void frmRecall_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Enter)
            {
                try
                {
                    if (this.ActiveControl.Name == "textToSearch")
                    {
                        getHistory(textToSearch.Text);
                        dataGridView1.Focus();
                    }
                    else
                    {
                        int row = dataGridView1.CurrentCell.RowIndex - 1;
                        if (row < 0) row = 0;
                        returnValue = dataGridView1.Rows[row].Cells[0].Value.ToString();
                        this.Close();
                    }
                }
                catch
                {
                }
            }
            else if (e.KeyData == Keys.Escape)
                this.Close();
        }

        private void dataGridView1_CellContentDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                int row = e.RowIndex;
                returnValue = dataGridView1.Rows[row].Cells[0].Value.ToString();
                this.Close();
            }
        }
        private void btnFind_Click(object sender, EventArgs e)
        {
            if (textToSearch.Text == "") return;

            getHistory(textToSearch.Text);
        }
        private void btnFindInto_Click(object sender, EventArgs e)
        {
            if (textToSearch.Text == "") return;

            DataRow[] v = ((DataTable)dataGridView1.DataSource).Select("sqlText like '%" + textToSearch.Text + "%'");

            DataTable dt = new DataTable();
            dt.Columns.Add("sqlText");
            DataRow rw;

            for (int i = v.Length - 1; i >= 0; i--)
            {
                rw = dt.NewRow();
                rw["sqlText"] = v[i][0].ToString();
                dt.Rows.Add(rw);
            }

            dataGridView1.DataSource = dt;
            dataGridView1.Columns[0].HeaderText = "SQL query text";
            dataGridView1.Columns[0].Width = dataGridView1.Width - 70;
        }
        private void getHistory(string filter)
        {
            try
            {
                netlib.netlib7 n7 = new netlib.netlib7();

                StreamReader f = new StreamReader(Environment.GetEnvironmentVariable("APPDATA") + @"\FreeSql\freeSQL.hst");
                string s = f.ReadToEnd();
                f.Close();
                if (s == "") return;

                string[] v = s.Split('\r', '\n');

                DataTable dt = new DataTable();
                dt.Columns.Add("sqlText");
                DataRow rw;
                for (int i = v.Length - 1; i >= 0; i--)
                {
                    if (v[i].Trim() != "" && v[i].IndexOf(filter, StringComparison.OrdinalIgnoreCase) >= 0)
                    {
                        rw = dt.NewRow();
                        rw["sqlText"] = v[i].Replace(((char)1).ToString(), "\r\n");
                        dt.Rows.Add(rw);
                    }
                }

                dataGridView1.DataSource = dt;
                dataGridView1.Columns[0].HeaderText = "SQL query text";
                dataGridView1.Columns[0].Width = dataGridView1.Width - 70;
            }
            catch
            {
            }
        }
    }
}